module Debug = Camlp4.Debug;
open Camlp4.PreCast;
open Format;
value sbprintf fmt =
  let buff = Buffer.create 42 in
  let f = formatter_of_buffer buff in
  kfprintf (fun f -> do { pp_print_flush f (); Buffer.contents buff }) f fmt;
module PP = Camlp4.Printers.OCamlr.Make Syntax;
value pp = new PP.printer ~comments:False ();
value _loc = Loc.ghost;

value bad s loc_of pp n t =
  Loc.raise (loc_of t) (Failure (sbprintf "%s: bad %s <<%a>>" n s pp t));

value bad_expr = bad "expression" Ast.loc_of_expr pp#expr;
value bad_patt = bad "pattern" Ast.loc_of_patt pp#patt;
value bad_str_item = bad "structure item" Ast.loc_of_str_item pp#str_item;
value bad_match_case = bad "match case" Ast.loc_of_match_case pp#match_case;
