type nb_proofs = Zero | Finite of Big_int.big_int | Infinite
val to_string_nb_proofs : nb_proofs -> string
val ( +% ) : nb_proofs -> nb_proofs -> nb_proofs
val ( *% ) : nb_proofs -> nb_proofs -> nb_proofs
val ( >=% ) : nb_proofs -> nb_proofs -> bool
val max_nb_proofs : nb_proofs -> nb_proofs -> nb_proofs

module CountState : functor (Pb : Set.OrderedType) ->
sig

type pb_set
val no_loop : pb_set
val is_looping : pb_set -> Pb.t -> bool
val contains_singleton : pb_set -> Pb.t -> bool
val singleton : Pb.t -> pb_set
val remove_loop : pb_set -> Pb.t -> pb_set

type count_state = { nb : nb_proofs; explored : bool; loop : pb_set; }
val unprovable : count_state
val is_unprovable : count_state -> bool
val ( +$ ) : count_state -> count_state -> count_state
val ( *$ ) : count_state -> count_state -> count_state
val count_one : count_state
val count_zero : count_state
val count_infinity : count_state
end
