open ExtList

exception IncorrectContext

module EnvLambda = Map.Make(Prop)

type env_lambda = LambdaBar.var list EnvLambda.t

(* TODO : Ugly ; let's hope that my wish-listbug gets accepted *)
let add_interpretation (env : env_lambda) p var =
  try EnvLambda.add p (var :: EnvLambda.find p env) env
  with Not_found -> EnvLambda.add p [var] env

let retrieve_term (env : env_lambda) prop i = 
  try List.nth (EnvLambda.find prop env) i
  with Failure "nth" -> raise IncorrectContext

let ref_var = ref 0

let new_var () =
  let r = !ref_var in
    incr ref_var;
    LambdaBar.namedvar (function
      | Options.Text -> Printf.sprintf "v%d" r
      | Options.LaTeX -> Printf.sprintf "v_{%d}" r)

let initial_env =
  List.fold_left (fun env p -> add_interpretation env p (new_var ())) 
    EnvLambda.empty

let print_env (e : env_lambda) = 
  EnvLambda.iter (fun p l -> 
    let p = Prop.to_string_ocaml p in
      List.iteri (fun i v -> Printf.printf "  val %s : %s\n" 
                    (LambdaBar.print_var v) p) l) e

let print_env_parseable (e : env_lambda) = 
  EnvLambda.iter (fun p l -> 
    let p = Prop.to_string_parseable p in
      List.iteri (fun i v -> Printf.printf "V %s %s\n" 
                    (LambdaBar.print_var v) p) l) e
