{
  open Parser_prop

  exception Eof
}

let int = ['0'-'9']['0'-'9']*

rule token = parse
  | [' ' '\t']        { token lexbuf }
  | 't'(int as i)     { TYPE (int_of_string i) }
  | '('               { LBRACE }
  | ')'               { RBRACE }
  | '&' | "/\\" | '*' { AND }
  | '|' | "\\/"       { OR }
  | "->"              { ARROW }
  | ','               { SEP }
  | ';'               { STOUP_SEP }
  | "|-"              { VDASH }
  | eof               { EOF }
