type t

val compare : t -> t -> int

type path = private
  | PAx
  | PNoChoice
  | PCont of (Prop.t * int) * t
  | PImpL of t * t
  | PImpR of t
  | PAndL of (int * int) * t
  | PAndR of t list
  | POrL of Prop.or_nb * t list
  | POrR of Prop.or_nb * (int * int) *  t

val ax : t
val nochoice : t
val cont : Prop.t -> int -> t -> t
val impl : t * t -> t
val impr : t -> t
val andl : int * int -> t -> t
val andr : t list -> t
val orl : Prop.or_nb -> t list -> t
val orr : Prop.or_nb -> int * int -> t -> t

val path_of_t : t -> path
