%{
(* Syntax *)
(* $Id: syntax.mly,v 1.7 2004/10/24 20:27:24 berke Exp $ *)
(* Prolog *)

open Parts
%}
%token EOF
%token MISSING
%token AND
%token BROKEN
%token IT
%token IN
%token IS
%token A
%token COLON
%token LPAREN
%token RPAREN
%token COMMA
%token PROMPT
%token PRISTINE
%token CONDITION
%token THE
%token DOT
%token L_BROKEN_R
%token <string> BLA
%token <string> PART
%token <int> COLOR
%type <Parts.prose list> prose
%start prose

%%
prose :
| PROMPT response EOF { [$2] }
| PROMPT response prose {
  match $2 with
  | Blah -> $3
  | _ -> $2 :: $3 }
| error prose { $2 }

response :
| THE
  p = BLA
  IS
  blabland
  DOT
  IT
  IS
  d = condition
  DOT
  { Part(p, d, -1) }
| THE
  p = PART
  IS
  blabla
  PART
  blabla
  IS
  c = COLOR
  blabla
  IT
  IS
  d = condition
  DOT
  { Part(p, d, c) }
| error { Blah }

blabland :
| dontcarend { }
| dontcarend blabland { }

dontcarend :
| COLOR { }
| BLA { }
| COMMA { }

blabla :
| dontcare { }
| dontcare blabla { }

condition :
| BROKEN COLON IT IS d = description { d }
| IN PRISTINE CONDITION { Pristine }

dontcare :
| BLA { }
| DOT { }
| COMMA { }

description :
| LPAREN description RPAREN { $2 }
| A PART { Number $2 }
| description MISSING description { Missing($3,$1) }
| description AND description { And($1,$3) }
